#include "plugin.h"
#include "MainWnd.h"

BOOL OnInit();
void OnQuit();
void OnTrackChange();
void OnStatusChange();
void OnConfig();

FITTLE_PLUGIN_INFO fpi = {
	PDK_VER,
	OnInit,
	OnQuit,
	OnTrackChange,
	OnStatusChange,
	OnConfig,
	NULL,
	NULL
};

HINSTANCE g_hInst = NULL;;
HWND g_hMainWnd = NULL;
HANDLE hThread  = NULL;

/* Xbh */
DWORD WINAPI ThreadFunc(LPVOID /*param*/)
{
	return MyWinMain();
}

/* Gg|g */
BOOL WINAPI _DllMainCRTStartup(HANDLE /*hModule*/, DWORD /*dwFunction*/, LPVOID /*lpNot*/){
    return TRUE;
}

/* NɈxĂ΂܂ */
BOOL OnInit(){
	// _~[EBhEĔ
	DWORD tid;
	hThread = CreateThread(NULL, 0, ThreadFunc, 0, 0, &tid);
	g_hInst = fpi.hDllInst;
	return hThread?TRUE:FALSE;
}

/* IɈxĂ΂܂ */
void OnQuit(){
	// ㏈ł
	SendMessage(g_hMainWnd, WM_DESTROY, 0, 0);
	WaitForSingleObject(hThread, INFINITE);
	CloseHandle(hThread);
	return;
}

/* Ȃς鎞ɌĂ΂܂ */
void OnTrackChange(){
	// gen_mixi_for_winamp.dll̓^Cgo[̃eLXg̐؂ւŐ؂ւ̊mĂۂ
	TAGINFO *ti = (TAGINFO *)SendMessage(fpi.hParent, WM_FITTLE, GET_TITLE, 0);
	char szBuff[512] = {0};
	wsprintf(szBuff, "%s - %s - Winamp", ti->szArtist, ti->szTitle);
	SetWindowText(g_hMainWnd, szBuff);
	return;
}

/* ĐԂς鎞ɌĂ΂܂ */
void OnStatusChange(){
	return;
}

/* ݒʂĂяo܂ij*/
void OnConfig(){
	return;
}

#ifdef __cplusplus
extern "C"
{
#endif
__declspec(dllexport) FITTLE_PLUGIN_INFO *GetPluginInfo(){
	return &fpi;
}
#ifdef __cplusplus
}
#endif